﻿using System;
using System.Collections;
using System.Collections.Generic;
using AVFoundation;
using Xamarin.Forms.Platform.iOS;
using Foundation;
using XP;

[assembly: Xamarin.Forms.Dependency(typeof(YOUR_NAMESPACE.iOS.XPushDelegate))]
namespace YOUR_NAMESPACE.iOS
{
    public class XPushDelegate : IXPushDelegate
    {
        public XPushDelegate()
        {
        }

        public void HitEvent(String eventName)
        {
            XP.XPush.HitEvent(eventName);
        }

        public void HitEvent(String eventName, String eventValue)
        {
            XP.XPush.HitEvent(eventName, eventValue);
        }

        public void HitTag(String tagName)
        {
            XP.XPush.HitTag(tagName);
        }

        public void HitTag(String tagName, String tagValue){
            XP.XPush.HitTag(tagName, tagValue);
        }

        public void OpenInbox()
        {
            XP.XPush.OpenInbox();
        }

        public void SetSubscription(Boolean sub)
        {
            XP.XPush.SetSubscription(sub);
        }

        public void SetExternalId(String ext)
        {
            XP.XPush.SetExternalId(ext);
        }

        public void SetUser(String user)
        {
            XP.XPush.SetUser(user);
        }

        public IDictionary<String, String> GetDeviceInfo()
        {
            IDictionary<String, String> genDict = new Dictionary<String, String>();
            NSDictionary mDict = XP.XPush.DeviceInfo;
            foreach(object key in mDict.Keys){
                String s = mDict[key as NSString].ToString();
                genDict.Add(key.ToString(), s);
            }
            return genDict;
        }

        public void GetPushList(uint offset, uint limit)
        {
            //replace null with callback function
            XP.XPush.GetPushNotificationsOffset(offset, limit, PushListCallback);
        }

        public void PushListCallback(Foundation.NSArray arg1, Foundation.NSError arg2) {
            try
            {
                for (nuint i = 0; i < arg1.Count; i++){
                    XP.XPMessage xpm = arg1.GetItem<XP.XPMessage>(i);
                    System.Diagnostics.Debug.WriteLine("XPushExample - create_time: " + xpm.Metadata["create_time"]);
                }
            } catch (Exception e)
            {
                System.Diagnostics.Debug.WriteLine("XPushExample - Empty message list received");
            }
        }

        public bool GetSubscription()
        {
            return XP.XPush.Subscription;
        }

        public void MarkPushAsRead(String messageId){
            XP.XPush.MarkPushAsRead(messageId);
        }
    }  
}